pref66h 	equ 1
pref67h 	equ 2
FNormCmd	equ	0
FJmpCmd		equ	1
FCallCmd	equ	2
FJccCmd		equ	3
FJcc32Cmd	equ	4
FRAsm		equ	5
FBadCmd		equ	6


disasm_struct           struct                  
		disasm_opcode	db	15 Dup (0)
		disasm_len		dd	?
		disasm_f66		db	?
		disasm_fSeg		db	?
		disasm_fRep		db	?
ends

ComandInfo 			struct
		InfCmd			disasm_struct ?
		_Flag			db	?
								; 0 - normal comand
								; 1 - jmp
								; 2 - call
								; 3 - jcc
								; 4 - 32b jcc
								; 6 - bad 
								; 5 - reserved for assemble
		_AddrComand		dd	?
		_NextrStr		dd	? 	; next stucure
		_PreStr			dd	? 	; previos stucture
		_NStr			dd	? 	; "virtual" address
		_Label			dd	? 	; 0 - nothing
								; if <> 0 Then address of structure of target
		_Xref			dd	?	; if <> 0 Then address of structure of transition
		_EPoint			db	?
		_NoMove			db	?
ends
SizeStruct	=	size ComandInfo

_BaseStr			struct
		_FlagTable		dd 	?
		_FreeMem		dd	? ; address free memory
		_HeadListStr	dd	? ; start list disassemble structure
		_CmdNum			dd	? ; amount of commands
		ListEnd			dd	? ; end list disassemble structure
		_TblOpcode		dd	? ; table of opcode
;-----
;any information
;-----
ends
;push	address enter point
;push	size free memory			
;push	size code
;push	address code
;push	free mem
;call	VPE_krn
;add	esp, 4*3
;if (eax == 0) 		--> all ok
;elseif	(eax == 1) 	--> flaw of memory
;				   	
;elseif (eax == -1) --> Unknow Error
;					--> Eror DASM
;					--> Calculate label error
VPE_krn:
		pusha
		mov		edi, [esp+32+4] ; free memory
		mov		esi, [esp+32+4+4] ; address code
		mov		ecx, [esp+32+4+4+4] ; size code
		mov		ebx, [esp+32+4+4+4+4] ; size free memory
		xor		eax, eax
		mov		edx, eax
_MainCycle: 
		cmp		esi, [esp+32+4+4+4+4+4]
		jnz		_SkipEPOint
		inc		1 ptr [edi]._EPoint
_SkipEPOint:
		mov		4 ptr [edi]._PreStr, eax
		call	DA1SM
		or		eax, eax
		jz		_ErrorUnknow
		sub		ecx, eax
		jz		_Ok
		js		_Ok
		add		esi, eax
		add		edx, SizeStruct
		cmp		edx, ebx
		jge		_ErrorMem
		mov		eax, edi
		add		eax, SizeStruct
		mov		4 ptr [edi]._NextrStr, eax
		xchg	eax, edi
		inc		1 ptr [ebp]._CmdNum
		jmp		_MainCycle
_Ok:
		xor		eax, eax              
		mov		4 ptr [ebp].ListEnd, edi
		mov		4 ptr [edi]._NextrStr, eax
		push	4 ptr [esp+32+4]
		call	PreProcc
		pop		ecx   
		inc		eax
		jz		_ErrorCalc
		xor		eax, eax
Exit:
		mov		[esp].popa_eax, eax
_OkAll:
		popa
		ret
_ErrorCalc:
		mov		eax, 2
		jmp		short Exit	
_ErrorUnknow:
		sbb		eax, eax
		jmp		short Exit	
_ErrorMem:
		xor		eax, eax
		inc		eax
		jmp		short Exit       
		
DA1SM:
		pusha
		push	esi
		call	mlde32
		pop		esi
		or		eax, eax
		jz		_ExitDASM
		mov		4 ptr [edi].disasm_len, eax
		mov		4 ptr [edi]._AddrComand, esi
		pushad
		xchg	ecx, eax
		rep		movsb
		popad
		lodsb
    	cmp     al, 0E8h
    	je      _ProcCall32
        cmp     al, 0E9h
        je      _ProcJmp32
        cmp     al, 0EBh
        je      _ProcJmp8b
        cmp		al, 066h
        jnz		_NotSetF66
        inc		1 ptr [edi].disasm_f66
_NotSetF66:
        mov		bl, al
        and     al, 11111110b    ; 64/65
        cmp     al, 01100100b
        jz		_SetFSeg
        mov		al, bl
        and     al, 11100111b   ; 26/2E/36/3E
        cmp     al, 00100110b
        jz		_SetFSeg
        mov		al, bl
        and		al, 011110011b
        sub		al, 011110000b ; F0
        jz		_SetFRep
        sub		al, 000000010b ; F2
        jz		_SetFRep
        dec		al ; F3
        jz		_SetFRep
        mov		al, bl
        and     al, 0F0h
        cmp     al, 70h
        je      _ProcJcc8b
        cmp		bl, 0Fh
        jnz		_ExitDASM
        lodsb
        and     al, 0F0h
        cmp     al, 80h
        je      _ProcJcc32h                    	
_ExitDASM:
		push	4 ptr [edi].disasm_len
		pop		4 ptr [esp].popa_eax
		popa
		ret
_ProcJecxz:
		mov		1 ptr [edi]._Flag, 6
		jmp		_ProcRel8b
_SetFSeg:
		inc		1 ptr [edi].disasm_fSeg
		jmp		_ExitDASM
_SetFRep:
		inc		1 ptr [edi].disasm_fRep
		jmp		_ExitDASM
_ProcJmp8b:
		mov		al, FJmpCmd
		jmp		_ProcR8b
_ProcJcc8b:			
		mov     al, FJccCmd
_ProcR8b:
		mov		1 ptr [edi]._Flag, al
_ProcRel8b:
        xor		eax, eax
        lodsb
        cmp		eax, 07Fh
        jg		__91
__92:
        lea     eax, [esi+eax]        					
		jmp		_skip1
__91:
		add		eax, 0FFFFFF00h
		jmp		__92
_ProcJmp32:
		mov		1 ptr [edi]._Flag, FJmpCmd
		jmp		_ProcAddr32 

_ProcJcc32h:
		mov		1 ptr [edi]._Flag, FJcc32Cmd
_ProcAddr32:
		lodsd
		lea		eax, [esi+eax]
		jmp		_skip1			          
		
_ProcCall32:
		mov		1 ptr [edi]._Flag, FCallCmd
		jmp		_ProcAddr32                     				  
_skip1:
		xchg	eax, [edi]._Label				
_ret:   jmp		_ExitDASM

;in:	ebx - root list
;out:	ecx - len code
;		eax - offset before enter point

CalcVAddr:
		pusha
		xor		eax, eax 
		mov		ecx, eax   
__@@3:
		mov		[ebx]._NStr, eax
		or		ecx, ecx
		jnz		_SkipEPoint
		mov		edx, eax
		inc		ecx
_SkipEPoint:
		add		eax, 4 ptr [ebx].disasm_len 
		mov		ebx, [ebx]._NextrStr
		or		ebx, ebx
		jnz		__@@3  
		mov		[esp].popa_ecx, eax 
		mov		[esp].popa_eax, edx 
		popa
		ret
		
VPE_asm:
		pusha
		mov		ebx, [esp+32+4] ; pointer to list structure
		mov		edi, [esp+32+8] ; free memory
		xor		ecx, ecx
_Assemble:
		cmp		[ebx]._Flag, 5h
		jnz		_SkipExd
		mov		esi, [ebx]._AddrComand
		add		ecx, [ebx].disasm_len
		push	ecx
		mov		ecx, [ebx].disasm_len
		rep movsb
		pop		ecx

		jmp		_Nextr
_SkipExd:
		mov		edx, [ebx]._Label
		or		edx, edx
		jz		__@@6 
        mov		eax, [edx]._NStr             
        sub		eax, [ebx]._NStr
        sub		eax, [ebx].disasm_len      
        lea		edx, [ebx].disasm_opcode
        inc		edx
        cmp		1 ptr [ebx]._Flag, 1
        jz		_WriteRel
        cmp		1 ptr [ebx]._Flag, 2
        jz		_WriteRel
        inc		edx
_WriteRel:
        mov		4 ptr [edx], eax
__@@6:
		push	ecx
		mov		esi, ebx
		mov		ecx, [ebx].disasm_len
		rep movsb
		pop		ecx
_Nextr:
		mov		eax, [ebx]._NextrStr
		or		eax, eax
		jz		_EndAssemble
		xchg	eax, ebx
		jmp		_Assemble
_EndAssemble:
		mov		[esp].popa_ecx, ecx
		popa
		ret
		

PreProcc:
		pusha
		mov		edi, [esp+32+4]      
		mov		edx, edi 
Main_Loop:
		movzx	eax, 1 ptr [edi]._Flag
		or		eax, eax
		jz		_Skip20
		dec		eax
		jnz		__I1
		mov		4 ptr [edi].disasm_len, 5
		mov		1 ptr [edi].disasm_opcode, 0E9h
		jmp		__@@Find
__I1:
		dec		eax
		jz		__@@Find
		dec		eax
		jz		_Jcc8b
		dec		eax
		jz		__@@Find
		jmp		_Skip20
_Jcc8b:
		mov		ah, 1 ptr [edi]
		mov		4 ptr [edi].disasm_len, 6
		add		ah, 10h
		mov		al, 0Fh
		mov		4 ptr [edi], eax
__@@Find:
		push	edx
		mov		eax, [edi]._Label
_@1:
		cmp		[edx]._AddrComand, eax
		jz		_@2
		mov		edx, [edx]._NextrStr
		or		edx, edx
		jz		_@@111
		jmp		_@1
_@2:
		mov		ebx, edx
		pop		edx
__@@4:
		mov		4 ptr [edi]._Label, ebx
		mov		4 ptr [ebx]._Xref, edi
_Skip20:
		mov		eax, [edi]._NextrStr
		or		eax, eax
		jz		_@@1
		xchg	eax, edi
		jmp		Main_Loop
_@@111:
		pop		edx
		sbb		eax, eax     
_@@1:
		mov		[esp].popa_eax, eax
		popa
		ret
;_Find:
;		push	edx
;		mov		eax, [edi]._Label
;_@1:
;		cmp		[edx]._AddrComand, eax
;		jz		_@2
;		mov		edx, [edx]._NextrStr
;		or		edx, edx
;		jz		_@@2
;		jmp		_@1
;		
;_@2:
;		mov		ebx, edx
;		pop		edx
;		clc
;		ret
;_@@2:
;		pop		edx
;		stc
;		ret   
